// 
// File:          decaf_Framework_Impl.cc
// Symbol:        decaf.Framework-v0.6.1
// Symbol Type:   class
// Babel Version: 0.8.4
// Description:   Server-side implementation for decaf.Framework
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.8.4
// 
#include "decaf_Framework_Impl.hh"

// DO-NOT-DELETE splicer.begin(decaf.Framework._includes)
#ifdef HAVE_NUMERIC_LIMITS
#include <limits>
#define LARGEST_INT std::numeric_limits<int32_t>::max()
#else 
#include <limits.h>
#define LARGEST_INT INT_MAX
#endif
#include <cstdio>  // for sprintf
#include "SIDL_BaseClass.hh"
#include "SIDL_Loader.hh"
#include "decaf_ComponentID.hh"
#include "decaf_Services.hh"
#include "decaf_TypeMap.hh"
#include "decaf_CCAException.hh"
#include "gov_cca_ports_EventType.hh"
#include "gov_cca_ports_ConnectionEventService.hh"
static char buffer[1024];
// DO-NOT-DELETE splicer.end(decaf.Framework._includes)

// user defined constructor
void decaf::Framework_impl::_ctor() {
  // DO-NOT-DELETE splicer.begin(decaf.Framework._ctor)
  // add construction details here
  // DO-NOT-DELETE splicer.end(decaf.Framework._ctor)
}

// user defined destructor
void decaf::Framework_impl::_dtor() {
  // DO-NOT-DELETE splicer.begin(decaf.Framework._dtor)
  // add destruction details here
  // DO-NOT-DELETE splicer.end(decaf.Framework._dtor)
}

// user defined static methods: (none)

// user defined non-static methods:
/**
 * Return the named port from the specified component id.
 */
::gov::cca::Port
decaf::Framework_impl::lookupPort (
  /*in*/ ::gov::cca::ComponentID componentID,
  /*in*/ const ::std::string& portName ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(decaf.Framework.lookupPort)
  std::string component = componentID.getInstanceName();
  gov::cca::Port port;
  if (d_instance.find(component) != d_instance.end()) {
    decaf::Services services = d_instance[component].second;
    port = services.getProvidesPort(portName);
  }
  return port;
  // DO-NOT-DELETE splicer.end(decaf.Framework.lookupPort)
}

/**
 * Framework creates providing component, registers provides port and connects to
 * using port for special cases (e.g. BuilderService)
 * @param type the string name of the port type (currently accepts only "gov.cca.ports.BuilderServices"
 * @param componentID the ID of the user component
 * @param portName the userPortName on the user component
 */
void
decaf::Framework_impl::provideRequestedServices (
  /*in*/ ::gov::cca::ComponentID componentID,
  /*in*/ const ::std::string& portName,
  /*in*/ const ::std::string& type ) 
throw () 
{
  // DO-NOT-DELETE splicer.begin(decaf.Framework.provideRequestedServices)
  if ( type == "gov.cca.ports.BuilderServices" ) { 
    // decaf.Framework itself provides Builder Services
    std::string uniqueName = getUniqueName( "builder" ); // get unique name
    gov::cca::Services svcs = getServices( uniqueName, type, 0 ); // create svcs
    svcs.addProvidesPort( self, "BuilderService", type, 0);
    self.connect( componentID, portName, svcs.getComponentID(), "BuilderService" );
  } else if ( type == "gov.cca.ports.ConnectionEventService" ) { 
    decaf::Services userSvcs = d_instance[componentID.getInstanceName()].second;
    // surprize! the services object itself provides the event services
    std::string uniqueName = getUniqueName( "connectionEventer" ); 
    gov::cca::Services svcs = getServices( uniqueName, type, 0 ); 
    svcs.addProvidesPort( userSvcs, "ConnectionEventService", type, 0 );
    self.connect( componentID, portName, svcs.getComponentID(), "ConnectionEventService" );
  }
  // DO-NOT-DELETE splicer.end(decaf.Framework.provideRequestedServices)
}

/**
 * 	Creates an instance of a CCA component of the type defined by the 
 * 	string className.  The string classname uniquely defines the
 * 	"type" of the component, e.g.
 * 	    doe.cca.Library.GaussianElmination. 
 * 	It has an instance name given by the string instanceName.
 * 	The instanceName may be empty (zero length) in which case
 * 	the instanceName will be assigned to the component automatically.
 * 	@throws CCAException If the Component className is unknown, or if the
 * 		instanceName has already been used, a CCAException is thrown.
 * 	@return A ComponentID corresponding to the created component. Destroying
 * 		the returned ID does not destroy the component; 
 * 		see destroyInstance instead.
 */
::gov::cca::ComponentID
decaf::Framework_impl::createInstance (
  /*in*/ const ::std::string& instanceName,
  /*in*/ const ::std::string& className,
  /*in*/ ::gov::cca::TypeMap properties ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.createInstance)
  SIDL::BaseClass sidl_class = SIDL::Loader::createClass( className );
  gov::cca::Component component = sidl_class;
  decaf::ComponentID cid = decaf::ComponentID::_create();
  if ( component._not_nil() ) { 
    std::string uniqueName = getUniqueName( instanceName );  
    cid.initialize( uniqueName );
    decaf::Services svc = decaf::Services::_create();
    svc.initialize( self, cid, properties, false );
    d_instance[ uniqueName ] = std::make_pair(component,svc);
    component.setServices( svc );
  }
  return cid;
// DO-NOT-DELETE splicer.end(decaf.Framework.createInstance)
}

/**
 *  Get component list.
 *  @return a ComponentID for each component currently created.
 */
::SIDL::array< ::gov::cca::ComponentID>
decaf::Framework_impl::getComponentIDs () 
throw ( 
  ::gov::cca::CCAException
)
{
  // DO-NOT-DELETE splicer.begin(decaf.Framework.getComponentIDs)
  int len = d_instance.size() -1;
  SIDL::array<gov::cca::ComponentID> retval = SIDL::array<gov::cca::ComponentID>::create1d( len );
  int i=0;
  for ( instanceName2Info_t::iterator it=d_instance.begin(); it!= d_instance.end(); ++it, ++i ) {
    retval.set( i, (*it).second.second.getComponentID() );
  }
  return retval;
  // DO-NOT-DELETE splicer.end(decaf.Framework.getComponentIDs)
}

/**
 *  Get property map for component.
 *  @return the public properties associated with the component referred to by
 *  ComponentID. 
 *  @throws a CCAException if the ComponentID is invalid.
 */
::gov::cca::TypeMap
decaf::Framework_impl::getComponentProperties (
  /*in*/ ::gov::cca::ComponentID cid ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.getComponentProperties)
  std::string instanceName = cid.getInstanceName();
  if ( d_instance.find( instanceName ) != d_instance.end() ) { 
    decaf::Services svcs = d_instance[ instanceName ].second;
    if ( svcs._not_nil() ) { 
      return svcs.getInstanceProperties();
    }
  }

  /*  
   * To Do...This is a "quickie fix" to get beyond the complaint of no
   *          return here but should give more thought as to a better
   *          solution (e.g., null pointer?).
   */
  decaf::CCAException dex = decaf::CCAException::_create();
  dex.setCCAExceptionType( gov::cca::Nonstandard );
  gov::cca::CCAException ex = dex;
  ex.setNote("Unable to get properties");
  ex.add( __FILE__, __LINE__, 
                "decaf::Framework_impl::getComponentProperties()");
  throw ex;
  // DO-NOT-DELETE splicer.end(decaf.Framework.getComponentProperties)
}

/**
 * 	Causes the framework implementation to associate the given properties 
 * 	with the component designated by cid. 
 * 	@throws CCAException if cid is invalid or if there is an attempted
 * 	change to a property locked by the framework implementation.
 */
void
decaf::Framework_impl::setComponentProperties (
  /*in*/ ::gov::cca::ComponentID cid,
  /*in*/ ::gov::cca::TypeMap map ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.setComponentProperties)
  std::string instanceName = cid.getInstanceName();
  if ( d_instance.find( instanceName ) != d_instance.end() ) {
    // downcast to access decaf-specific routines
    decaf::Services svcs =  d_instance[ instanceName ].second;
    if ( svcs._not_nil() ) { 
      svcs.setInstanceProperties( map );
    }
  }
  // DO-NOT-DELETE splicer.end(decaf.Framework.setComponentProperties)
}

/**
 * Get component id from stringified reference.
 *    @return a ComponentID from the string produced by 
 * 	ComponentID.getSerialization(). 
 *    @throws CCAException if the string does not represent the appropriate 
 * 	 serialization of a ComponentID for the underlying framework.
 */
::gov::cca::ComponentID
decaf::Framework_impl::getDeserialization (
  /*in*/ const ::std::string& s ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.getDeserialization)
  decaf::CCAException dex = decaf::CCAException::_create();
  dex.setCCAExceptionType( gov::cca::Nonstandard );
  gov::cca::CCAException ex = dex;
  ex.setNote("Sorry: Decaf does not implement component serialization/deserialization");
  ex.add( __FILE__, __LINE__, "decaf::Framework_impl::getProvidedPortNames()");
  throw ex;
  // DO-NOT-DELETE splicer.end(decaf.Framework.getDeserialization)
}

/**
 * Get id from name by which it was created.
 *  @return a ComponentID from the instance name of the component
 *  produced by ComponentID.getInstanceName().
 *  @throws CCAException if there is no component matching the 
 *  given componentInstanceName.
 */
::gov::cca::ComponentID
decaf::Framework_impl::getComponentID (
  /*in*/ const ::std::string& componentInstanceName ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.getComponentID)
  if ( d_instance.find( componentInstanceName ) != d_instance.end() ) { 
    return d_instance[ componentInstanceName ].second.getComponentID();
  } else { 
    return 0;
  }
  // DO-NOT-DELETE splicer.end(decaf.Framework.getComponentID)
}

/**
 *  Eliminate the Component instance, from the scope of the framework.
 *  @param toDie the component to be removed.
 *  @param timeout the allowable wait; 0 means up to the framework.
 *  @throws CCAException if toDie refers to an invalid component, or
 *  if the operation takes longer than timeout seconds.
 */
void
decaf::Framework_impl::destroyInstance (
  /*in*/ ::gov::cca::ComponentID toDie,
  /*in*/ float timeout ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.destroyInstance)
  d_instance.erase( toDie.getInstanceName() );
  d_connection.erase( toDie.getInstanceName() );
  // DO-NOT-DELETE splicer.end(decaf.Framework.destroyInstance)
}

/**
 *  Get the names of Port instances provided by the identified component.
 *  @param cid the component.
 *  @throws CCAException if cid refers to an invalid component.
 */
::SIDL::array< ::std::string>
decaf::Framework_impl::getProvidedPortNames (
  /*in*/ ::gov::cca::ComponentID cid ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.getProvidedPortNames)
  std::string instanceName = cid.getInstanceName();
  if ( d_instance.find( instanceName ) != d_instance.end() ) { 
    decaf::Services svcs = d_instance[ instanceName ].second;
    if ( svcs._not_nil() ) { 
      return svcs.getProvidedPortNames();
    } else { 
      decaf::CCAException dex = decaf::CCAException::_create();
      dex.setCCAExceptionType( gov::cca::Nonstandard );
      gov::cca::CCAException ex = dex;
      ex.setNote("downcast from gov::cca::Services to decaf::Services failed");
      ex.add( __FILE__, __LINE__, "decaf::Framework_impl::getProvidedPortNames()");
      throw ex;
    } 
  } else { 
    decaf::CCAException dex = decaf::CCAException::_create();
    dex.setCCAExceptionType( gov::cca::Nonstandard );
    gov::cca::CCAException ex = dex;
    sprintf( buffer, "componentID with instanceName=\"%s\" not found.", instanceName.c_str() );
    ex.setNote(buffer);
    ex.add( __FILE__, __LINE__, "decaf::Framework_impl::getProvidedPortNames()");
    throw ex;
  }
  // DO-NOT-DELETE splicer.end(decaf.Framework.getProvidedPortNames)
}

/**
 *  Get the names of Port instances used by the identified component.
 *  @param cid the component.
 *  @throws CCAException if cid refers to an invalid component. 
 */
::SIDL::array< ::std::string>
decaf::Framework_impl::getUsedPortNames (
  /*in*/ ::gov::cca::ComponentID cid ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.getUsedPortNames)
  std::string instanceName = cid.getInstanceName();
  if ( d_instance.find( instanceName ) != d_instance.end() ) { 
    decaf::Services svcs = d_instance[ instanceName ].second;
    if ( svcs._not_nil() ) { 
      return svcs.getUsedPortNames();
    } else { 
      decaf::CCAException dex =  decaf::CCAException::_create();
      dex.setCCAExceptionType( gov::cca::Nonstandard );
      gov::cca::CCAException ex = dex;
      ex.setNote("downcast from gov::cca::Services to decaf::Services failed");
      ex.add( __FILE__, __LINE__, "decaf::Framework_impl::getUsedPortNames()");
      throw ex;
    } 
  } else { 
    decaf::CCAException dex = decaf::CCAException::_create();
    dex.setCCAExceptionType( gov::cca::Nonstandard );
    gov::cca::CCAException ex = dex;
    sprintf( buffer, "componentID with instanceName=\"%s\" not found.", instanceName.c_str() );
    ex.setNote(buffer);
    ex.add( __FILE__, __LINE__, "decaf::Framework_impl::getUsedPortNames()");
    throw ex;
  }
  // DO-NOT-DELETE splicer.end(decaf.Framework.getUsedPortNames)
}

/**
 *  Fetch map of Port properties exposed by the framework.
 *  @return the public properties pertaining to the Port instance 
 *    portname on the component referred to by cid. 
 *  @throws CCAException when any one of the following conditions occur:<ul>
 *    <li>portname is not a registered Port on the component indicated by cid,
 *    <li>cid refers to an invalid component. </ul>
 */
::gov::cca::TypeMap
decaf::Framework_impl::getPortProperties (
  /*in*/ ::gov::cca::ComponentID cid,
  /*in*/ const ::std::string& portName ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.getPortProperties)
  std::string instanceName = cid.getInstanceName();
  if ( d_instance.find( instanceName ) != d_instance.end() ) { 
    decaf::Services svcs = d_instance[ instanceName ].second;
    if ( svcs._not_nil() ) { 
      return svcs.getPortProperties( portName );
    }
  }
  return 0;
  // DO-NOT-DELETE splicer.end(decaf.Framework.getPortProperties)
}

/**
 *  Associates the properties given in map with the Port indicated by 
 *  portname. The component must have a Port known by portname.
 *  @throws CCAException if either cid or portname are
 * 	invalid, or if this a changed property is locked by 
 * 	 the underlying framework or component.
 */
void
decaf::Framework_impl::setPortProperties (
  /*in*/ ::gov::cca::ComponentID cid,
  /*in*/ const ::std::string& portName,
  /*in*/ ::gov::cca::TypeMap map ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.setPortProperties)
  std::string instanceName = cid.getInstanceName();
  if ( d_instance.find( instanceName ) != d_instance.end() ) { 
    decaf::Services svcs = d_instance[ instanceName].second;
    if ( svcs._not_nil() ) { 
      svcs.setPortProperties( portName, map );
    }
  }
  // DO-NOT-DELETE splicer.end(decaf.Framework.setPortProperties)
}

/**
 *   Creates a connection between ports on component user and 
 *   component provider. Destroying the ConnectionID does not
 *   cause a disconnection; for that, see disconnect().
 *   @throws CCAException when any one of the following conditions occur:<ul>
 *   <li>If either user or provider refer to an invalid component,
 *   <li>If either usingPortName or providingPortName refer to a 
 * 	 nonexistent Port on their respective component,
 *   <li>If other-- In reality there are a lot of things that can go wrong 
 * 	 with this operation, especially if the underlying connections 
 * 	 involve networking.</ul>
 */
::gov::cca::ConnectionID
decaf::Framework_impl::connect (
  /*in*/ ::gov::cca::ComponentID user,
  /*in*/ const ::std::string& usingPortName,
  /*in*/ ::gov::cca::ComponentID provider,
  /*in*/ const ::std::string& providingPortName ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.connect)
  decaf::ConnectionID connectID;
  std::string userName = user.getInstanceName();
  std::string provName = provider.getInstanceName();
  if ( ( d_instance.find( userName ) != d_instance.end() ) &&
       ( d_instance.find( provName ) != d_instance.end() ) ) { // iff both ports exist.
	decaf::Services userSvc = d_instance[ userName ].second;
	decaf::Services provSvc = d_instance[ provName ].second;
	// Yikes!!!! should check if types match.
	// okay, fire a connect pending.  Connections fired at providers first, users 2nd
	provSvc.notifyConnectionEvent( providingPortName, gov::cca::ports::ConnectPending );
	userSvc.notifyConnectionEvent( providingPortName, gov::cca::ports::ConnectPending );
	gov::cca::Port port = provSvc.getProvidesPort( providingPortName );
	if ( port._not_nil() ) {
	  userSvc.bindPort( usingPortName, port );
	  connectID = decaf::ConnectionID::_create();
	  connectID.initialize( user, usingPortName, provider, providingPortName, 0);
	  d_connection[ userName ][ usingPortName ] = connectID;
	  provSvc.notifyConnectionEvent( providingPortName, gov::cca::ports::Connected );
	  userSvc.notifyConnectionEvent( providingPortName, gov::cca::ports::Connected );
	}
  }
  return connectID;
  // DO-NOT-DELETE splicer.end(decaf.Framework.connect)
}

/**
 * Returns a list of connections as an array of 
 * 	handles. This will return all connections involving components 
 * 	in the given componentList of ComponentIDs. This
 * 	means that ConnectionID's will be returned even if only one 
 * 	of the participants in the connection appears in componentList.
 * 
 * 	@throws CCAException if any component in componentList is invalid.
 */
::SIDL::array< ::gov::cca::ConnectionID>
decaf::Framework_impl::getConnectionIDs (
  /*in*/ ::SIDL::array< ::gov::cca::ComponentID> componentList ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.getConnectionIDs)
  decaf::CCAException dex = decaf::CCAException::_create();
  dex.setCCAExceptionType( gov::cca::Nonstandard );
  gov::cca::CCAException ex = dex;
  ex.setNote("Method not implemented");
  ex.add(__FILE__, __LINE__, "decaf::Framework_impl::getConnectionIDs(...)");
  throw ex;
  // DO-NOT-DELETE splicer.end(decaf.Framework.getConnectionIDs)
}

/**
 *   Fetch property map of a connection.
 *   @returns the properties for the given connection.
 *   @throws CCAException if connID is invalid.
 */
::gov::cca::TypeMap
decaf::Framework_impl::getConnectionProperties (
  /*in*/ ::gov::cca::ConnectionID connID ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.getConnectionProperties)
  decaf::ConnectionID cid = connID;
  if ( cid._not_nil() ) { 
    return cid.getProperties();
  } else { 
    return 0;
  }
  // DO-NOT-DELETE splicer.end(decaf.Framework.getConnectionProperties)
}

/**
 * Associates the properties with the connection.
 *   @param map the source of the properties.
 *   @param connID connection to receive property values.
 *   @throws CCAException if connID is invalid, or if this changes 
 * 	 a property locked by the underlying framework.
 */
void
decaf::Framework_impl::setConnectionProperties (
  /*in*/ ::gov::cca::ConnectionID connID,
  /*in*/ ::gov::cca::TypeMap map ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.setConnectionProperties)
  std::string userName = connID.getUser().getInstanceName();
  if ( d_connection.find( userName ) != d_connection.end() ) { 
    std::string userPortName = connID.getUserPortName();
    std::map< std::string, gov::cca::ConnectionID> &lev2 = d_connection[ userName ];
    if ( lev2.find( userPortName ) != lev2.end() ) { 
      // downcast to access decaf-specifics
      decaf::ConnectionID connID = lev2[ userPortName ];
      if ( connID._not_nil() ) { 
	connID.setProperties( map );
      }
    }
  }
  // DO-NOT-DELETE splicer.end(decaf.Framework.setConnectionProperties)
}

/**
 * Disconnect the connection indicated by connID before the indicated
 *     timeout in secs. Upon successful completion, connID and the connection
 *     it represents become invalid. 
 *     @param timeout the time in seconds to wait for a connection to close; 0
 *     means to use the framework implementation default.
 *     @throws CCAException when any one of the following conditions occur: <ul>
 *     <li>id refers to an invalid ConnectionID,
 *     <li>timeout is exceeded, after which, if id was valid before 
 * disconnect() was invoked, it remains valid
 * </ul>
 * 
 */
void
decaf::Framework_impl::disconnect (
  /*in*/ ::gov::cca::ConnectionID connID,
  /*in*/ float timeout ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.disconnect)
  std::string userName = connID.getUser().getInstanceName();
  std::string userPortName = connID.getUserPortName();
  std::string provName = connID.getProvider().getInstanceName();
  std::string provPortName = connID.getProviderPortName();
  decaf::Services userSvcs = d_instance[userName].second;
  decaf::Services provSvcs = d_instance[provName].second;
  userSvcs.notifyConnectionEvent( userPortName, gov::cca::ports::DisconnectPending );
  provSvcs.notifyConnectionEvent( provPortName, gov::cca::ports::DisconnectPending );
  if ( d_connection.find( userName ) != d_connection.end() ) { 
    d_connection[userName].erase( userPortName );
    userSvcs.notifyConnectionEvent( userPortName, gov::cca::ports::Disconnected );
    provSvcs.notifyConnectionEvent( provPortName, gov::cca::ports::Disconnected );
  }
  // DO-NOT-DELETE splicer.end(decaf.Framework.disconnect)
}

/**
 * Remove all connections between components id1 and id2 within 
 *   the period of timeout secs. If id2 is null, then all connections 
 *   to id1 are removed (within the period of timeout secs).
 *   @throws CCAException when any one of the following conditions occur:<ul>
 * 	  <li>id1 or id2 refer to an invalid ComponentID (other than id2 == null),
 * 	  <li>The timeout period is exceeded before the disconnections can be made. 
 * 	  </ul>
 */
void
decaf::Framework_impl::disconnectAll (
  /*in*/ ::gov::cca::ComponentID id1,
  /*in*/ ::gov::cca::ComponentID id2,
  /*in*/ float timeout ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.disconnectAll)
  d_connection.erase( d_connection.begin(), d_connection.end() );
  // DO-NOT-DELETE splicer.end(decaf.Framework.disconnectAll)
}

/**
 *  Create an empty TypeMap. Presumably this would be used in 
 *  an ensuing call to <code>getServices()</code>. The "normal" method of
 *  creating typemaps is found in the <code>Services</code> interface. It
 *  is duplicated here to break the "chicken and egg" problem.
 */
::gov::cca::TypeMap
decaf::Framework_impl::createTypeMap () 
throw ( 
  ::gov::cca::CCAException
)
{
  // DO-NOT-DELETE splicer.begin(decaf.Framework.createTypeMap)
  return decaf::TypeMap::_create();
  // DO-NOT-DELETE splicer.end(decaf.Framework.createTypeMap)
}

/**
 * Retrieve a Services handle to the underlying framework. 
 * This interface effectively causes the calling program to 
 * appear as the image of a component inside the framework.
 * This method may be called any number of times
 * with different arguments, creating a new component image 
 * each time. 
 * The only proper method to destroy a Services obtained 
 * from this interface is to pass it to releaseServices.
 * 
 * @param selfInstanceName the Component instance name,
 * as it will appear in the framework.
 * 
 * @param selfClassName the Component type of the 
 * calling program, as it will appear in the framework. 
 * 
 * @param selfProperties (which can be null) the properties 
 * of the component image to appear. 
 * 
 * @throws CCAException in the event that selfInstanceName 
 * is already in use by another component.
 * 
 * @return  A Services object that pertains to the
 * 	    image of the this component. This is identical
 * 	    to the object passed into Component.setServices() 
 * 	    when a component is created.
 */
::gov::cca::Services
decaf::Framework_impl::getServices (
  /*in*/ const ::std::string& selfInstanceName,
  /*in*/ const ::std::string& selfClassName,
  /*in*/ ::gov::cca::TypeMap selfProperties ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.getServices)
  gov::cca::Component nil;
  decaf::ComponentID cid = decaf::ComponentID::_create();
  std::string uniqueName = getUniqueName( selfInstanceName );
  cid.initialize( uniqueName );
  decaf::Services svcs = decaf::Services::_create();
  svcs.initialize( self, cid, selfProperties, true);
  d_instance[ uniqueName ] = std::make_pair( nil, svcs );
  d_aliases[ uniqueName ] = selfClassName ;
  return svcs;
  // DO-NOT-DELETE splicer.end(decaf.Framework.getServices)
}

/**
 * Inform framework that the <code>Services</code> handle is no longer needed by the 
 * caller and that the reference to its component image is to be
 * deleted from the context of the underlying framework. This invalidates
 * any <code>ComponentID</code>'s or <code>ConnectionID</code>'s associated 
 * with the given <code>Services</code>' component image. 
 * 
 * @param svc The result of getServices earlier obtained.
 * 
 * @throws CCAException if the <code>Services</code>
 *         handle has already been released or is otherwise rendered invalid 
 *         or was not obtained from <code>getServices()</code>.
 */
void
decaf::Framework_impl::releaseServices (
  /*in*/ ::gov::cca::Services svc ) 
throw ( 
  ::gov::cca::CCAException
){
  // DO-NOT-DELETE splicer.begin(decaf.Framework.releaseServices)
  // insert implementation here
  // DO-NOT-DELETE splicer.end(decaf.Framework.releaseServices)
}

/**
 * Tell the framework it is no longer needed and to clean up after itself. 
 *  @throws CCAException if the framework has already been shutdown.
 */
void
decaf::Framework_impl::shutdownFramework () 
throw ( 
  ::gov::cca::CCAException
)
{
  // DO-NOT-DELETE splicer.begin(decaf.Framework.shutdownFramework)
  // insert implementation here
  // DO-NOT-DELETE splicer.end(decaf.Framework.shutdownFramework)
}

/**
 * Creates a new framework instance based on the same underlying 
 * framework implementation. This does not copy the existing 
 * framework, nor are any of the user-instantiated components in
 * the original framework available in the newly created 
 * <code>AbstractFramework</code>. 
 * 
 * @throws CCAException when one of the following conditions occur:
 * 
 * (1)the AbstractFramework previously had shutdownFramework() called on it, or 
 * (2)the underlying framework implementation does not permit creation 
 * of another instance.	 
 */
::gov::cca::AbstractFramework
decaf::Framework_impl::createEmptyFramework () 
throw ( 
  ::gov::cca::CCAException
)
{
  // DO-NOT-DELETE splicer.begin(decaf.Framework.createEmptyFramework)
  return decaf::Framework::_create();
  // DO-NOT-DELETE splicer.end(decaf.Framework.createEmptyFramework)
}


// DO-NOT-DELETE splicer.begin(decaf.Framework._misc)
std::string
decaf::Framework_impl::getUniqueName (
      /*in*/ std::string requestedName )
{
  std::string name = requestedName;
  if (d_instance.find( name ) != d_instance.end() ) { 
    for (int i=0; i<LARGEST_INT; ++i) { 
      char buf[64];
      std::sprintf(buf,"%d",i);
      name = requestedName + buf;
      if (d_instance.find( name ) == d_instance.end() ) { 
	break;
      }
    }
  }
  return name;
}
// DO-NOT-DELETE splicer.end(decaf.Framework._misc)

