#
# File:          SortTest_Impl.py
# Symbol:        sort.SortTest-v0.1
# Symbol Type:   class
# Babel Version: 0.8.4
# Description:   Implementation of SIDL class sort.SortTest in Python.
# 
# WARNING: Automatically generated; changes will be lost
# 
# babel-version = 0.8.4
#


"""Run a bunch of sorts through a stress test.
"""

# DO-NOT-DELETE splicer.begin(_initial)
# Put your code here...
# DO-NOT-DELETE splicer.end(_initial)

import sort.SortingAlgorithm
import SIDL.BaseInterface
import SIDL.BaseClass
import SIDL.ClassInfo
import sort.SortTest

# DO-NOT-DELETE splicer.begin(_before_static)
import sort.Container
import sort.CompInt
import sort.Comparator
import sort.IntegerContainer

testSizes = [ 0, 1, 2, 3, 4, 7, 10, 51, 100 ]

def notSorted(cont, comp):
  size = cont.length()
  for i in xrange(1, size):
    if (cont.compare(i-1, i, comp) > 0):
      return 1
  return 0

def sortAndReport(alg, cont, comp, result):
  alg.reset()
  alg.sort(cont, comp)
  swpCnt = alg.getSwapCounter()
  cmpCnt = alg.getCompareCounter()
  print "COMMENT: compares (", cmpCnt.getCount(), ") swaps (", \
        swpCnt.getCount(), ")"
  if (notSorted(cont, comp)):
    print "COMMENT: sort failed!!"
    result = 0
  return result
# DO-NOT-DELETE splicer.end(_before_static)

def stressTest(algs):
  #
  # SIDL EXPECTED INCOMING TYPES
  # ============================
  # array<sort.SortingAlgorithm> algs
  #

  #
  # SIDL EXPECTED RETURN VALUE(s)
  # =============================
  # bool _return
  #

  """\
Perform the array stress test.

Return true if all the algorithms work okay.
"""
  # DO-NOT-DELETE splicer.begin(stressTest)
  result = 1
  for alg in algs:
    data = sort.IntegerContainer.IntegerContainer()
    cont = sort.Container.Container(data)
    intcomp = sort.CompInt.CompInt()
    comp = sort.Comparator.Comparator(intcomp)
    name = alg.getName()
    print "COMMENT: ****ALGORITHM IS", name, "****"
    for size in testSizes:
      intcomp.setSortIncreasing(1)
      print "COMMENT: DATA SIZE", size
      data.setLength(size)
      result = sortAndReport(alg, cont, comp, result)
      print "COMMENT: pre-sorted list"
      result = sortAndReport(alg, cont, comp, result)
      print "COMMENT: reverse sorted list"
      intcomp.setSortIncreasing(0)
      result = sortAndReport(alg, cont, comp, result)
  return result
  # DO-NOT-DELETE splicer.end(stressTest)

# DO-NOT-DELETE splicer.begin(_before_type)
# Put your code here...
# DO-NOT-DELETE splicer.end(_before_type)

class SortTest:
  """\
Run a bunch of sorts through a stress test.
"""

  # All calls to SIDL methods should use __IORself

  def __init__(self, IORself):
    self.__IORself = IORself
    # DO-NOT-DELETE splicer.begin(__init__)
    # Put your code here...
    # DO-NOT-DELETE splicer.end(__init__)

# DO-NOT-DELETE splicer.begin(_final)
# Put your code here...
# DO-NOT-DELETE splicer.end(_final)
